/* File: elimvett.c */
/* Time-stamp: "2001-05-22 00:18:51 calvanes" */
/* Scopo: funzioni sui vettori */

bool EliminaDaVettore(TipoVettore A, TipoElemVettore elem, int *n, int *posiz)
  /* Elimina l'elemento elem tra i primi n elementi del vettore ordinato A.
     Il valore di ritorno e` TRUE se elem era presente in A ed e` stato
     eliminato, FALSE altrimenti.
     Se elem era presente in A, posiz contiene l'indice dell'elemento di A che
     era pari ad elem, ed n viene decrementato di uno.
     Utilizza la funzione RicercaBinaria. */
{
  int i;

  if (RicercaBinaria(A, elem, *n, posiz)) {
    (*n)--;
    for (i = *posiz;  i < *n; i++)
      A[i] = A[i+1];
  }
} /* EliminaDaVettore */
