/* File: ricesau.c */
/* Time-stamp: "2001-05-25 15:06:10 calvanes" */
/* Scopo: ricerca in un vettore */

bool RicercaEsaustiva(TipoVettore A, TipoElemVettore elem, int n, int *posiz)
  /* Effettua la ricerca esaustiva di elem tra i primi n elementi di A.
     Il valore di ritorno e` TRUE se elem e` presente in A,
     FALSE altrimenti.  Se elem e` presente in A, posiz contiene l'indice della
     componente pari ad elem. */
{
  int i = -1;
  bool trovato = FALSE;

  do i++;
  while (i < n-1 && A[i] != elem );
  if (A[i] == elem) {
    trovato = TRUE;
    *posiz = i;
  }

  return trovato;
} /* RicercaEsaustiva */
