/* File: vettio.c */
/* Time-stamp: "2001-02-18 22:23:27 calvanes" */
/* Scopo: funzioni di lettura di vettore da file e
                      scrittura di vettore su file */


int LeggiVettore(char *nomefile, TipoVettore A, int n)
  /* Legge dal file di nome nomefile al piu` n elementi del vettore di interi
     A.  Restituisce il numero effettivo di elementi letti. */
{
  int i = 0;
  FILE *datafile;

  datafile = fopen(nomefile, "r");
  if (datafile == NULL) {
    fprintf(stderr, "Errore aprendo il file `%s' in lettura\n", nomefile);
    i = 0;
  }
  else {
    while (i < n && fscanf(datafile, "%d", &A[i]) == 1)
      i++;

    fclose(datafile);
  }

  return i;
}  /* LeggiVettore */


void ScriviVettore(char *nomefile, TipoVettore A, int n)
  /* Scrive i primi n elementi del vettore di interi A sul file di nome
     nomefile. */
{
  int i;
  FILE *datafile;

  datafile = fopen(nomefile, "w");
  if (datafile == NULL)
    fprintf(stderr, "Errore aprendo il file `%s' in scrittura\n", nomefile);
  else {
    for (i = 0; i < n; i++)
      fprintf(datafile, "%d ", A[i]);
    fclose(datafile);
  }
}  /* ScriviVettore */
