/* File: occorcif.c */
/* Time-stamp: "2002-05-01 01:57:35 calvanes" */
/* Scopo: esempio di uso di stringhe */

/* Legge una stringa di lunghezza DIM, e stampa il numero di occorrenze
   delle cifre contenute nella stringa.
   Esempio:
   se la stringa inserita e' "lettere12e3375cifre1953"
   l'output del programma sara':
   
   la cifra 1 compare 2 volte
   la cifra 2 compare 1 volta
   la cifra 3 compare 3 volte
   la cifra 5 compare 2 volte
   la cifra 7 compare 1 volta
   la cifra 9 compare 1 volta
 */

#include <stdio.h>
#include <string.h>
#include <ctype.h>

#define DIM 80


int main(void) {

  char testo[DIM];
  int occorrenze[10] = { 0 };
       /* Vettore che conta le occorrenze.  L'elemento i-esimo del vettore
          conterra` il numero di occorrenze della cifra i nella stringa.
          Ad esempio l'elemento occorrenze[3] conta il numero di volte che la
          cifra 3 compare nella stringa. */
  int i, indice;

  /* leggi stringa */
  printf("Inserisci una stringa contenente lettere e cifre:\n");
  scanf("%s", testo);

  /* legge tutti i caratteri della stringa. Se il carattere e` una cifra i
     allora viene incrementato di uno l'elemento i-esimo del vettore
     occorrenze. */
  for (i = 0; testo[i] != '\0'; i++)
    if (testo[i] >= '0' && testo[i] <= '9') {
      indice = testo[i] - '0';
      occorrenze[indice]++;
    }

  /* stampa il numero di occorrenze delle cifre */
  for (i = 0; i < 10; i++)
    if (occorrenze[i] > 0) {
      printf("La cifra %d occorre %d ", i, occorrenze[i]);
      if (occorrenze[i] == 1)
        printf("volta\n");
      else
        printf("volte\n");
    }

  return 0;
}
