/* File: strconca.c */
/* Time-stamp: "2002-05-01 00:53:04 calvanes" */
/* Scopo: esempio di uso di stringhe */

/* Legge due stringhe di lunghezza DIM e inserisce la seconda alla fine della
   prima.  Le tre funzioni conc1, conc2, conc3 illustrano metodi diversi per
   concatenare 2 stringhe. */

#include <stdio.h>

#define DIM 80


void conc1(char * str1, char * str2)
  /* Inserisce str2 alla fine di str1. */
{
  int i = 0, j = 0;

  while (str1[i] != '\0')
    i++;
  while (str2[j] != '\0') {
    str1[i] = str2[j];
    i++;
    j++;
  }
  str1[i] = '\0';
}


void conc2(char * str1, char * str2)
  /* Inserisce str2 alla fine di str1. Versione compatta. */
{
  int i = 0, j = 0;

  while (str1[i] != '\0')
    i++;
  while ((str1[i] = str2[j]) != '\0') {
    i++;
    j++;
  }
}


void conc3(char * str1, char * str2)
  /* Inserisce str2 alla fine di str1. Versione con i puntatori. */
{
  while (*str1 != '\0')
    str1++;
  while ((*str1 = *str2) != '\0') {
    str1++;
    str2++;
  }
}


int main(void)
{
  char s1[DIM];
  char s2[DIM];

  /* leggi le due stringhe */
  printf("Inserisci la prima stringa:\n");
  scanf("%s", s1);
  printf("Inserisci la seconda stringa:\n");
  scanf("%s", s2);

  conc1(s1, s2);
  /* conc2(s1, s2); */
  /* conc3(s1, s2); */

  /* stampa le due stringhe */
  printf("La prima stringa e`  : %s\n", s1);
  printf("La seconda stringa e`: %s\n", s2);

  return 0;
}
