/* File: strcopia.c */
/* Time-stamp: "2001-04-22 00:42:15 calvanes" */
/* Scopo: esempio di uso di stringhe */

/* Legge due stringhe di lunghezza DIM e copia la seconda nella prima.
   Le tre funzioni copia1, copia2, copia3 illustrano metodi diversi per copiare
   2 stringhe. */

#include <stdio.h>

#define DIM 80

void copia1(char * str1, char * str2)
  /* Copia la stringa str2 nella stringa str1.
     Assume che str1 sia lunga almeno quanto str2. */
{
  int i = 0;

  while (str2[i] != '\0') {
    str1[i] = str2[i];
    i++;
  }
  str1[i] = '\0';
}

void copia2(char * str1, char * str2)
  /* Copia la stringa str2 nella stringa str1. Versione compatta.
     Assume che str1 sia lunga almeno quanto str2. */
{
  int i = 0;

  while ((str1[i] = str2[i]) != '\0')
    i++;
}

void copia3(char * str1, char * str2)
  /* Copia la stringa str2 nella stringa str1. Versione con i puntatori.
     Assume che str1 sia lunga almeno quanto str2. */
{
  while ((*str1 = *str2) != '\0') {
    str1++;
    str2++;
  }
}


int main(void) {

  char s1[DIM];
  char s2[DIM];

  /* leggi una stringa */
  printf("Inserisci una stringa:\n");
  scanf("%s", s2);

  copia1(s1, s2);
  /* copia2(s1, s2); */
  /* copia3(s1, s2); */

  /* stampa le due stringhe. Da notare che sono uguali */
  printf("La prima stringa e`  : %s\n", s1);
  printf("La seconda stringa e`: %s\n", s2);

  return 0;
}
