/* File: intlim.c */
/* Time-stamp: "2001-03-19 00:33:12 calvanes" */
/* Scopo: caratteristiche dei tipi int, short, long */

/* Stampa numero byte occupati e l'intervallo di definizione per tipi:
   int, short, long */

#include <stdio.h>
#include <limits.h>

int main(void)
{
  printf("Un oggetto short occupa: sizeof(short) = %d byte\n", sizeof(short));
  printf("Intervallo definizione short: SHRT_MIN = %d, SHRT_MAX = %d\n\n",
         SHRT_MIN, SHRT_MAX);

  printf("Un oggetto int occupa: sizeof(int) = %d byte\n", sizeof(int));
  printf("Intervallo definizione int: INT_MIN = %d, INT_MAX = %d\n\n",
         INT_MIN, INT_MAX);

  printf("Un oggetto long occupa: sizeof(long) = %d byte\n", sizeof(long));
  printf("Intervallo definizione long: LONG_MIN = %d, LONG_MAX = %d\n\n",
         LONG_MIN, LONG_MAX);

  return 0;
}

/* output (gcc su linux i386):

Un oggetto int occupa: sizeof(int) = 4 byte
Intervallo definizione int: INT_MIN = -2147483648, INT_MAX = 2147483647

Un oggetto short occupa: sizeof(short) = 2 byte
Intervallo definizione short: SHRT_MIN = -32768, SHRT_MAX = 32767

Un oggetto long occupa: sizeof(long) = 4 byte
Intervallo definizione long: LONG_MIN = -2147483648, LONG_MAX = 2147483647

*/
